<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class DENTAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'DENT (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'dent-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 5;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'DENT';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#666666';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x3597bfD533a99c9aa083587B074434E61Eb0A258';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xA5a4484aDF71164Ea5d4030a3a5AF252777c522F';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/dent.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'dent';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(10000000000);
    }
}