<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class ELONAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Dogelon (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'elon-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 9;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 8;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'ELON';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#FBC37D';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x761D38e5ddf6ccf6Cf7c55759d5210750B5D60F3';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x87BF0B5f03C394FAf53C746298cB11b86dcCDB14';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/elon.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'dogelon';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000000000);
    }
}