<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class EURSAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'STASIS EURS Token (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'eurs-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 2;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'EURS';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#8547EC';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0xdB25f211AB05b1c97D595516F45794528a807ad8';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xDfc5B4E1EdF568a2b2251eD9684F4d2d8f5bbB36';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/eurs.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'stasis-euro';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000);
    }
}