<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class FUNAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'FunFair (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'fun-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 4;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'FUN';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#ED1968';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x419D0d8BdD9aF5e606Ae2232ed285Aff190E711b';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x8481DfFC2D75C13eAD195646e8e9Dde666BF60Ae';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/fun.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'funtoken';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000000);
    }
}