<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class GLMAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Golem Network Token (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'glm-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'GLM';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#181EA9';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x7DD9c5Cba05E151C895FDe1CF355C9A1D5DA6429';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xcA3f65AFF6111c14840B7efbb73191162c1CDBb2';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/glm.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'golem-network-tokens';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(10000000);
    }
}