<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class GUSDAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Gemini dollar (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'gusd-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 2;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'GUSD';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#00DCFA';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x056Fd409E1d7A124BD7017459dFEa2F387b6d5Cd';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xde3b6e36773235d734E39598F8B1490a1d0093b2';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/gusd.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'gemini-dollar';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000);
    }
}