<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class IOSTAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'IOSToken (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'iost-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 3;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'IOST';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#77B7FF';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0xFA1a856Cfa3409CFa145Fa4e20Eb270dF3EB21ab';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x2e021138bEE726230D1d09BAd57f40D62EdAE8A5';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/iost.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'iostoken';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(100000000);
    }
}