<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class IOTXAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'IoTeX Network (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'iotx-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 3;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'IOTX';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#00D4D5';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x6fB3e0A217407EFFf7Ca062D46c26E5d60a14d69';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x7Ab949D6B6666125F4A60A3402F69AA9EAE8F591';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/iotx.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'iotex';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(100000000);
    }
}