<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class LEOAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'UNUS SED LEO (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'leo-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'LEO';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#F6A02F';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x2AF5D2aD76741191D15Dfe7bF6aC92d4Bd912Ca3';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x85fc1133b62471F9618f3AcdBaCE9Dd4BE888da5';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/leo.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'unus-sed-leo';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(0.1);
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000);
    }
}