<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class REVAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Revain (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'rev-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 6;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 5;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'REV';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#751A4E';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x2ef52Ed7De8c5ce03a4eF0efbe9B7450F2D7Edc9';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x03d3012ccC76a227a19d44cf51dA61f845522C97';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/rev.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'revain';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(10000000000);
    }
}