<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class RLCAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'RLC (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'rlc-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 9;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'RLC';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#FFD800';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x607F4C5BB672230e8672085532f7e901544a7375';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x4C763b54cd0dc4bf06eb3DDC158171A14a7C4e96';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/rlc.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'rlc';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000);
    }
}