<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class SPELLAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Spell Token (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'spell-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 5;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'SPELL';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#7572EF';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x090185f2135308BaD17527004364eBcC2D37e5F6';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x884dF1F8064737dC592e815B7684D424FbFc30bC';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/spell.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'spell-token';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(10000000000);
    }
}