<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class TELAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Telcoin (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'tel-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 2;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 4;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'TEL';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#12B3E4';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x467Bccd9d29f223BcE8043b84E8C8B282827790F';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x441A49AB73Af6c79D565e56D0C91f5E3c86E8395';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/tel.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'telcoin';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000000);
    }
}