<?php

namespace App\Plugins\EthereumBundle;

use App\CoinAdapters\Abstracts\AbstractEthereumTokenAdapter;
use Brick\Math\BigDecimal;

class ZILAdapter extends AbstractEthereumTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Zilliqa (ERC)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'zil-erc';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 3;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'ZIL';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#49C1BF';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x05f4a42e251f2d52b8ed15E9FEdAacFcEF1FAD27';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x20CaD0AB3484a65E24472083da2a6F62BEC71e94';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/ethereum-bundle/zil.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return 'zilliqa';
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000000);
    }
}